; Array fr Spielemap
Global Dim game_map(15, 15)


; Tile und Spielfigur Grssen
TSDim = 32


; Jump&Run - Engine initialisieren
XIncludeFile "jnr_routines_v1_4.pbi"
jnr_init(15, 15, TSDim, TSDim)


; jnr_map() - Daten einlesen
Dim jnr_map(15, 15)
Restore jnr_data
For z1 = 0 To 15
  For z2 = 0 To 15
    Read jnr_map(z1, z2)
  Next z2
Next z1


; Spielfigur erstellen und positionieren
jnr_addplayers(1, 4)
jnr_setpos(0, 1 * TSDim, 10 * TSDim)


If InitSprite() And InitKeyboard()
  If OpenScreen(1024, 768, 32, "Tutorial")


    ; Spielfigur
    CreateSprite(0, TSDim, TSDim)
    StartDrawing(SpriteOutput(0))
      DrawingMode(#PB_2DDrawing_Default)
      Box(0, 0, TSDim, TSDim, RGB(0, 80, 0))
      DrawingMode(#PB_2DDrawing_Outlined)
      Box(0, 0, TSDim, TSDim, RGB(0, 120, 0))
    StopDrawing()
    

    ; Mauer
    CreateSprite(1, TSDim, TSDim)
    StartDrawing(SpriteOutput(1))
      DrawingMode(#PB_2DDrawing_Default)
      Box(0, 0, TSDim, TSDim, RGB(80, 80, 80))
      DrawingMode(#PB_2DDrawing_Outlined)
      Box(0, 0, TSDim, TSDim, RGB(120, 120, 120))
    StopDrawing()
    
    
    ; Gamemap laden
    For z1 = 0 To 15
      For z2 = 0 To 15
        Read game_map(z1, z2)
      Next z2
    Next z1
    

    ; Geschwindigkeit kann hier angepasst werden
    SetFrameRate(120)
    

    ; Loop-Schleife
    Repeat
      ExamineKeyboard()
      If KeyboardPushed(#PB_Key_Escape)
        End
      EndIf
      
      ; Spielfigur steuern      
      If KeyboardPushed(#PB_Key_Space)
        jnr_jumping(0, 2 * TSDim, 0)
      EndIf
      If KeyboardPushed(#PB_Key_Right)
        jnr_right(0)
      EndIf
      If KeyboardPushed(#PB_Key_Left)
        jnr_left(0)
      EndIf
      
      ClearScreen(RGB(0, 0, 0))
      
      ; Zugriff auf Engine
      jnr_loop()
      
      ; Map anzeigen
      For z1 = 0 To 15
        For z2 = 0 To 15
          If game_map(z1, z2) > 0
            DisplayTransparentSprite(game_map(z1, z2), z2 * TSDim, z1 * TSDim)
          EndIf
        Next z2
      Next z1
      
      ; Spielfigur anzeigen
      DisplayTransparentSprite(0, jnr()\x, jnr()\y)
      
      FlipBuffers(0)
    ForEver
    
    
  EndIf
EndIf


; Map-Daten
DataSection
jnr_data:
; Info-Daten fr die Jump&Run - Engine 
;
; Typ               | Begehbar?
; -----------------------------
; 0 = -             | (#False)
; 1 = -             | (#True)
; 2 = Wolke (Cloud) | (#True)
; 3 = Leiter        | (#True)
; ...
Data.l 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
Data.l 0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0
Data.l 0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0
Data.l 0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0
Data.l 0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0
Data.l 0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0
Data.l 0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0
Data.l 0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0
Data.l 0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0
Data.l 0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0
Data.l 0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0
Data.l 0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0
Data.l 0,1,1,0,0,1,1,1,1,1,1,0,0,1,1,0
Data.l 0,1,1,1,1,0,0,1,1,0,0,1,1,1,1,0
Data.l 0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0
Data.l 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0


game_data:
; Tiles:
; 0 = Leer
; 1 = Mauersprite
Data.l 1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1
Data.l 1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1
Data.l 1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1
Data.l 1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1
Data.l 1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1
Data.l 1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1
Data.l 1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1
Data.l 1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1
Data.l 1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1
Data.l 1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1
Data.l 1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1
Data.l 1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1
Data.l 1,0,0,1,1,0,0,0,0,0,0,1,1,0,0,1
Data.l 1,0,0,0,0,1,1,0,0,1,1,0,0,0,0,1
Data.l 1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1
Data.l 1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1
EndDataSection
